/* GemRB - Infinity Engine Emulator
 * Copyright (C) 2003 The GemRB Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: CHUImp.h 4503 2007-02-27 16:43:46Z wjpalenstijn $
 *
 */

#ifndef CHUIMP_H
#define CHUIMP_H

#include "../Core/WindowMgr.h"
#include "../Core/DataStream.h"

/**CHU File Importer Class
  *@author GemRB Developement Team
  */

class CHUImp : public WindowMgr {
private:
	DataStream* str;
	bool autoFree;
	ieDword WindowCount, CTOffset, WEOffset;
public: 
	CHUImp();
	~CHUImp();
	/** Returns the number of available windows */
	unsigned int GetWindowsCount();
	/** Returns the i-th window in the Previously Loaded Stream */
	Window* GetWindow(unsigned int i);
	/** This function loads all available windows from the 'stream' parameter. */
	bool Open(DataStream* stream, bool autoFree = true);
public:
	void release(void)
	{
		delete this;
	}
};

#endif
